;Tutorial 6. Animieren der Figuren
; Noch laufen die einzelnen Figuren ohne irgendwelche Bewegung. Dies wollen wir nun abndern.
; Dazu mussten die Grafiken verndert werden. Die Grafiken bestehen jetzt aus mehreren Bildern, 
; die zusammengefasst wieder in eine Grafikdatei gepackt wurde. Dieses ist ntig um die einzelnen 
; Bewegungsablufe darzustellen. Die Gre der Figuren (32*32) hat sich aber nicht gendert, sondern
; es werden nun Einzelbilder (Frames) dargestellt. 


Graphics 640,480

SetBuffer BackBuffer()
frametimer = CreateTimer (30)
ClsColor 0, 0, 255


Global tile = LoadImage ("tile2.bmp")
MaskImage tile, 255, 0, 255

Global hero = LoadAnimImage ("dude2.bmp", 32, 32, 0, 8)	
;Anstelle LoadImage verwenden wir jetzt LoadAnimImage. Die Parameter geben zuerst die Gre
;der verwendeten Grafik an, dann der erste Frame und wieviele Frames vorhanden sind
MaskImage hero, 255, 0, 255

Global bomb = LoadImage ("bomb.bmp")
MaskImage bomb, 255, 0, 255

Global Monster1 = LoadAnimImage ("monster1b.bmp", 32, 32, 0, 8)
Global Monster2 = LoadAnimImage ("monster2b.bmp", 32, 32, 0, 8)
MaskImage Monster1, 255, 0, 255
MaskImage Monster2, 255, 0, 255



Global Player_pos_x = 200
Global Player_pos_y = 320
Global Player_temp_y# = 0
Global Player_Counter = 8, Player_Frame = 0	;SpielerFrame
Global jump
Global jumptimer#

Const rauf = 200, runter = 208, rechts = 205, links = 203, space = 57 



Global anzahl=0
Global info.bomb

Type bomb
Field Pos_x
Field Pos_y
End Type 


Global info2.Monster

Type Monster
Field Monstertype
Field Pos_x
Field Pos_y
Field Richtung
Field Animcounter
Field Frame 
End Type 

 
Dim map (20,15)

Restore mapdata
For y=0 To 14
	For x=0 To 19
		Read map(x,y)
	Next
Next



Restore bomb_level1
Read anzahl
For i = 1 To anzahl
	info.bomb = New bomb
	Read x, y
	info\Pos_x = x
	info\Pos_Y = y
Next 		


Restore monster_level1
Read anzahl
For i = 1 To anzahl
	info2.Monster = New Monster
	Read Monstertype, x, y, richtung,counter,frame
	info2\Monstertype = Monstertype
	info2\Pos_x = x
	info2\Pos_y = y
	info2\Richtung = Richtung
	info2\Animcounter = counter	; Hiermit berechnen wir, wie schnell sich die Animation verndert.
	info2\Frame = frame	; Dieses Field wurde hinzugefgt, um den jeweiligen Frame abzufragen
Next 		

;Die Hauptschleife
Repeat

Cls
WaitTimer (frametimer)

DrawMap()
Movehero()
DoJump()
DrawBomb()
DrawPlayer()
MoveMonster()
DrawMonster()
Collision()

Flip

Until KeyHit (1) 
End


;Functionen
Function DrawMap()
	For y = 0 To 14
		For x = 0 To 19
			If map(x,y) = 1 Then
				DrawImage tile, x*32, y*32
			EndIf 
		Next
	Next
End Function  


Function Movehero()
	If KeyDown(links) Then
		If Player_Frame <4 Then Player_Frame = 4	;sobald der Frame kleiner als 4 ist auf 4 setzen
		Player_Counter = Player_Counter -1			;Zhler minimieren
		If Player_Counter = 0 Then					;Sobald Zhler Null erreicht hat
			Player_Counter = 8						;Zhler auf neuen Wert setzen
			Player_Frame = Player_Frame +1			;Frame erhhen
			If Player_Frame = 8 Then Player_Frame = 4	;Sollte Frame grer als 8 sein, auf 4 zurcksetzen
		EndIf 				
		If map(Player_pos_x /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x -4
			If Player_pos_x =< 0 Then Player_pos_x = 1
		EndIf
	ElseIf KeyDown(rechts) Then	;Genauso verhlt es sich, wenn die Figur nach Rechts luft, nur das
		If Player_Frame >3 Then Player_Frame = 0	; hier die ersten 4 Frames gebraucht werden.
		Player_Counter = Player_Counter -1
		If Player_Counter = 0 Then
			Player_Counter = 8
			Player_Frame = Player_Frame +1
			If Player_Frame = 4 Then Player_Frame = 0
		EndIf 
		If map((Player_pos_x +32) /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x +4
			If Player_pos_x => 608 Then Player_pos_x = 607
		EndIf
	EndIf 
End Function 


	
Function DoJump()
	
	If KeyDown (space) Then
		If jump = False
			jump = True
			Player_temp_y = 15
		EndIf 
	EndIf
	
	
	If map((Player_pos_x +16) /32,Player_pos_y /32)=1 And jump = True Then
		jump = False
		Player_pos_y = Player_pos_y +1	
	EndIf 
	
	 
	If jump = True Then
		Player_temp_y = Player_temp_y -0.33
		Player_pos_y = Player_pos_y - Player_temp_y
		If Player_temp_y =< 0 Then 
			If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=1 Then
				jump = 0
				temp = Player_pos_y /32
				Player_pos_y = temp *32
			EndIf
		EndIf
	 EndIf 
	
	
	If jump = False  Then
		If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=0 Then	
			jump = True 
			Player_temp_y = 0
		EndIf 
	EndIf 
	
	
	If Player_pos_y =< 0 Then
		Player_pos_y = 1
		jump = True 
		Player_Temp_y = 0
	EndIf
	
	If Player_pos_y => 448 Then 
		Player_pos_y = 447 
		jump = False 
	EndIf 
		
End Function 
	


Function DrawPlayer()
	DrawImage hero, Player_pos_x, Player_pos_y,Player_Frame 
	;Drawimage wird nur um einen weiteren Parameter, dem Frame, erweitert 
End Function 



Function DrawBomb()
	For info.bomb = Each bomb
		DrawImage bomb, info\Pos_x, info\Pos_y
	Next 
End Function 



Function DrawMonster()
	For info2.Monster = Each Monster
		If info2\Monstertype = 1 Then
			DrawImage Monster1, info2\Pos_x, info2\Pos_y, info2\frame
			;Auch hier wird ein weiterer Parameter (Frame) hinzugefgt.
		ElseIf info2\Monstertype = 2 Then
			DrawImage Monster2, info2\Pos_x, info2\Pos_y, info2\frame
		EndIf 
	Next 
End Function 



Function MoveMonster()
	For info2.Monster = Each Monster
		If info2\Monstertype = 2 Then 
			If info2\Richtung = 1 Then 
				info2\Pos_x = info2\Pos_x +2
				If info2\Frame >3 Then info2\Frame = 0	
				;Genauso, wie wir es mit der Spielfigur gelst haben,
				;lsen wir das Problem mit der Animation auch bei den Monstern
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 4 Then info2\Frame = 0
				EndIf 
				If map((info2\Pos_x +16) /32,(info2\Pos_y +32) /32)=0 Then
					info2\Richtung = 0
				EndIf 
			ElseIf info2\Richtung = 0 Then 
				info2\Pos_x = info2\Pos_x -2
				If info2\Frame <4 Then info2\Frame = 4
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 8 Then info2\Frame = 4
				EndIf 
				If map((info2\Pos_x +16) /32,(info2\Pos_y +32) /32)=0 Then
					info2\Richtung = 1
				EndIf 			
			EndIf
	
		ElseIf info2\Monstertype = 1 Then
			If info2\Pos_x < Player_Pos_x Then
				info2\Pos_x = info2\Pos_x +1
				info2\Richtung = 1
			ElseIf info2\Pos_x > Player_Pos_x Then
				info2\Pos_x = info2\Pos_x -1
				info2\Richtung = 0
				If info2\Frame <4 Then info2\Frame = 4
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 8 Then info2\Frame = 4
				EndIf 				
			EndIf 
			If info2\Pos_y < Player_Pos_y Then
				info2\Pos_y = info2\Pos_y +1
			ElseIf info2\Pos_y > Player_Pos_y Then
				info2\Pos_y = info2\Pos_y -1
			EndIf
			
			If info2\Richtung = 1 Then
				If info2\Frame >3 Then info2\Frame = 0
		 		info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 4 Then info2\Frame = 0
				EndIf 
 			ElseIf info2\Richtung = 0
				If info2\Frame <4 Then info2\Frame = 4
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 8 Then info2\Frame = 4
				EndIf 				
			EndIf 
		EndIf
	Next
End Function 



Function Collision()
	
	For info.bomb = Each bomb
		If ImagesCollide (bomb, info\Pos_x, info\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
			Delete info.bomb
		EndIf
	Next
	
	
	For info2.Monster = Each Monster
		If info2\Monstertype = 1 Then 
			If ImagesCollide (Monster1, info2\Pos_x, info2\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
				Text 100,100, "Leben verloren 1"
			EndIf 
		ElseIf info2\Monstertype = 2 Then
			If ImagesCollide (Monster2, info2\Pos_x, info2\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
				Text 100,100, "Leben verloren 2"
			EndIf 		 	
		EndIf
	Next
End Function 



.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.bomb_level1
Data 25
Data 32,64
Data 64,64
Data 96,64
Data 128,64
Data 160,64
Data 448,64
Data 480,64
Data 512,64
Data 544,64
Data 576,64
Data 224,192
Data 256,192
Data 288,192
Data 320,192
Data 352,192
Data 32,320
Data 64,320
Data 96,320
Data 128,320
Data 160,320
Data 448,320
Data 480,320
Data 512,320
Data 544,320
Data 576,320


.monster_level1
Data 6
Data 1, 32, 32, 1, 8, 0
Data 2, 96, 64, 1, 8, 0
Data 2, 512, 64, 0, 8, 4
Data 2, 288, 192, 1, 8, 0
Data 2, 96, 320, 1, 8, 0
Data 2, 512, 320, 0, 8, 4